module Workbox
  module Text
    PAIR_MAP = {
      '{' => '}',
      '[' => ']',
      '(' => ')',
      ')' => '(',
      ']' => '[',
      '}' => '{',
      '>' => '<',
      '<' => '>',
    }

    def wrap(opening, closing=nil)
      closing = opening.reflect unless closing
      to_s.clone.insert(0, opening) << closing
    end

    def reflect
      to_s.each_char.map do |char|
        PAIR_MAP.fetch(char) { char }
      end.reverse.join
    end

    def slug
      to_s.gsub(/[\s-]/, '_').gsub(/[,.?!+-=]/, '')
    end
  end
end
